//
//  ViewController.swift
//  CD-Notifications
//
//  Created by bulko on 11/1/24.
//

import UIKit
import UserNotifications

var pickerData = ["1", "2", "3", "4", "5", "10", "20", "30"]

class ViewController: UIViewController, UIPickerViewDelegate, UIPickerViewDataSource {

    @IBOutlet weak var picker: UIPickerView!
    
    override func viewDidLoad() {
        super.viewDidLoad()
        picker.delegate = self
        picker.dataSource = self
    }
    
    func numberOfComponents(in pickerView: UIPickerView) -> Int {
        // number of columns in the picker
        return 1
    }
    
    func pickerView(_ pickerView: UIPickerView, numberOfRowsInComponent component: Int) -> Int {
        return pickerData.count
    }
    
    func pickerView(_ pickerView: UIPickerView, titleForRow row: Int, forComponent component: Int) -> String? {
        return pickerData[row]
    }

    @IBAction func requestBtnPushed(_ sender: Any) {
        
        UNUserNotificationCenter.current().requestAuthorization(
            options: [.alert, .badge, .sound]) { (granted, error) in
                if granted {
                    print("All set!")
                } else if let error = error {
                    print(error.localizedDescription)
                }
        }
    }
    
    @IBAction func scheduleBtnPushed(_ sender: Any) {
        
        // get the selected value from the picker
        let pickerRow = picker.selectedRow(inComponent: 0)
        let pickerValue = Double(pickerData[pickerRow])!
        
        // create content
        let content = UNMutableNotificationContent()
        content.title = "Here's your notification"
        content.subtitle = "After \(pickerValue) seconds"
        content.sound = .default
        
        // create trigger
        let trigger = UNTimeIntervalNotificationTrigger(
            timeInterval: pickerValue,
            repeats: false)
        
        // combine it all into a request
        let request = UNNotificationRequest(
            identifier: "myNotification",
            content: content,
            trigger: trigger)
        
        UNUserNotificationCenter.current().add(request)
        
    }
    
}

